package com.zbf.system.service;

import java.util.List;
import java.util.Map;

import com.zbf.system.domain.*;

/**
 * 入库通知单Service接口
 *
 * @author tony
 * @date 2024-06-18
 */
public interface ITRkWareNoticeService
{
    /**
     * 查询入库通知单
     *
     * @param id 入库通知单主键
     * @return 入库通知单
     */
    public TRkWareNotice selectTRkWareNoticeById(String id);

    public TRkWareNotice selectTRkWareNoticeByNoticeId(String id);

    public TRkWareNotice selectTRkWareNoticeByDeliveryId(String id);

    /**
     * 查询入库通知单列表
     *
     * @param tRkWareNotice 入库通知单
     * @return 入库通知单集合
     */
    public List<TRkWareNotice> selectTRkWareNoticeList(TRkWareNotice tRkWareNotice);

    /**
     * 导出入库通知单列表
     *
     * @param tRkWareNotice 入库通知单
     * @return 入库通知单集合
     */
    public List<TRkWareNotice> exportTRkWareNoticeList(TRkWareNotice tRkWareNotice);

    /**
     * 新增入库通知单
     *
     * @param tRkWareNotice 入库通知单
     * @return 结果
     */
    public int insertTRkWareNotice(TRkWareNotice tRkWareNotice);

    /**
     * 修改入库通知单
     *
     * @param tRkWareNotice 入库通知单
     * @return 结果
     */
    public int updateTRkWareNotice(TRkWareNotice tRkWareNotice);

    /**
     * 批量删除入库通知单
     *
     * @param ids 需要删除的入库通知单主键集合
     * @return 结果
     */
    public int deleteTRkWareNoticeByIds(String[] ids);

    /**
     * 批量删除入库通知单明细
     *
     * @param ids 需要删除的入库通知单主键集合
     * @return 结果
     */
    public Map<String, String> deleteTRkWareNoticeTabByIds(String[] ids);

    /**
     * 删除入库通知单信息
     *
     * @param id 入库通知单主键
     * @return 结果
     */
    public int deleteTRkWareNoticeById(String id);

    /**
     * 批量禁用入库通知单
     *
     * @param ids 需要禁用的入库通知单主键集合
     * @return 结果
     */
    public int disabledTRkWareNoticeByIds(String[] ids);

    /**
     * 批量启用入库通知单
     *
     * @param ids 需要启用的入库通知单主键集合
     * @return 结果
     */
    public int enableTRkWareNoticeByIds(String[] ids);

    /**
     * 改变状态
     *
     * @param tRkWareNotice
     * @return 结果
     */
    public int updateStatus(TRkWareNotice tRkWareNotice);

    /**
     * 收货
     * @param params
     * @return
     */
    public Map<String, String> confirmNoticeTab(TRkWareNoticeTabUpdate params);

    /**
     * 保存
     * @param params
     * @return
     */
    public Map<String, String> saveNoticeTab(TRkWareNoticeTabUpdate params);

    /**
     * 手动完成
     * @param params
     * @return
     */
    public Map<String, String> manualCompletion(TRkWareNoticeTabUpdate params);

    /**
     * 上架确认
     * 
     * @param params
     * @return
     */
    public Map<String, String> shelvesConfirm(TRkWareNoticeTabUpdate params);

    String importData(List<TRkWareNoticeTab> trList, boolean updateSupport, String operName);

    public Map<String, String> sendOrderNotice(TRkWareNoticeTabUpdate update);

    public Map<String, String> handAddGoodsTab(TRkWareNoticeTabUpdate update);

    Map<String, String> sendIwmsUnified(TRkWareNoticeTabUpdate update);



    Map<String, String> virtualListing(TCkOrders orders);

    public Map<String, String> workshopReturn(TckOrdersBak orders);

    String importExcelData(List<TRkWareNoticeTabExcel> trList, boolean updateSupport, String operName);
}

